DocMkrParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
DocMkrParser Class Referencefinal

the main class to read a DocMake file More...

`#include <DocMkrParser.hxx>`

Inheritance diagram for DocMkrParser:

## Public Member Functions
| DocMkrParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~DocMkrParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches)
void | newPage (int number)
| adds a new page
bool | createZones ()
| finds the different objects zones
bool | readPictInfo (MWAWEntry const &entry)
| try to read a pict info zone ? ( resource pInf )
bool | readSTwD (MWAWEntry const &entry)
| try to read an unknown zone ( resource sTwD )
bool | readXtr2 (MWAWEntry const &entry)
| try to read an unknown zone ( resource xtr2 )
bool | sendPicture (int zId, int lId, double lineW)
| try to send a picture knowing zId and local id
void | flushExtra ()
| sends the data which have not yet been sent to the listener
MWAWInputStreamPtr | rsrcInput ()
| return the input input
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< DocMkrParserInternal::State > | m_state
| the state
std::shared_ptr< DocMkrText > | m_textParser
| the text parser

## Friends
class | DocMkrText

## Detailed Description

the main class to read a DocMake file

## Constructor & Destructor Documentation

## ◆ DocMkrParser()

DocMkrParser::DocMkrParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~DocMkrParser()

DocMkrParser::~DocMkrParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool DocMkrParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void DocMkrParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool DocMkrParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ flushExtra()

void DocMkrParser::flushExtra | ( |  | ) |
| protected

sends the data which have not yet been sent to the listener

Referenced by parse().

## ◆ getPageLeftTop()

MWAWVec2f DocMkrParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

## ◆ init()

void DocMkrParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by DocMkrParser().

## ◆ newPage()

void DocMkrParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by DocMkrText::sendMainText(), and DocMkrText::sendText().

## ◆ parse()

void DocMkrParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readPictInfo()

bool DocMkrParser::readPictInfo | ( | MWAWEntry const & | entry | ) |
| protected

try to read a pict info zone ? ( resource pInf )

Referenced by createZones().

## ◆ readSTwD()

bool DocMkrParser::readSTwD | ( | MWAWEntry const & | entry | ) |
| protected

try to read an unknown zone ( resource sTwD )

Referenced by createZones().

## ◆ readXtr2()

bool DocMkrParser::readXtr2 | ( | MWAWEntry const & | entry | ) |
| protected

try to read an unknown zone ( resource xtr2 )

Referenced by createZones().

## ◆ rsrcAscii()

libmwaw::DebugFile & DocMkrParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by createZones(), DocMkrText::readFontNames(), DocMkrText::readFooter(), readPictInfo(), readSTwD(), DocMkrText::readStyles(), DocMkrText::readTOC(), DocMkrText::readWindows(), readXtr2(), and DocMkrText::sendText().

## ◆ rsrcInput()

MWAWInputStreamPtr DocMkrParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by DocMkrText::computeNumPages(), DocMkrText::readFontNames(), DocMkrText::readFooter(), readPictInfo(), readSTwD(), DocMkrText::readStyles(), DocMkrText::readTOC(), DocMkrText::readWindows(), readXtr2(), DocMkrText::sendComment(), sendPicture(), DocMkrText::sendText(), and DocMkrText::updatePageSpanList().

## ◆ sendPicture()

bool DocMkrParser::sendPicture | ( | int | zId,
|  | int | lId,
|  | double | lineW )
| protected

try to send a picture knowing zId and local id

Referenced by DocMkrText::sendText().

## Friends And Related Symbol Documentation

## ◆ DocMkrText

friend class DocMkrText
| friend

Referenced by init().

## Member Data Documentation

## ◆ m_state

std::shared_ptr<DocMkrParserInternal::State> DocMkrParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), flushExtra(), init(), newPage(), readPictInfo(), and sendPicture().

## ◆ m_textParser

std::shared_ptr<DocMkrText> DocMkrParser::m_textParser
| protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), and sendPicture().

The documentation for this class was generated from the following files:

- DocMkrParser.hxx
- DocMkrParser.cxx